/* 
   Version 1.0							1996/11/30

   makeexe.cmd : This file is part of the alliance 3.0 patch for OS/2

   Copyright (C) 1996 Christoph Jaeschke, jaeschke@item.uni-bremen.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

"@echo off"
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

DEBUGEXE="NO"	/* "YES" let all *.exe files print some
		   debugging informations when invoked */

/* ------------- Function : Main --------------- */


EMX_INC="E:/EMX/include"
REXX_ALLIANCE_BIN="\ALLIANCE\ARCHI\EMX\BIN"
REXX_ALLIANCE_LIB="\ALLIANCE\ARCHI\EMX\LIB"
REXX_ALLIANCE_TOOLS="\ALLIANCE\TOOLS"
ALLIANCE_BIN="/ALLIANCE/ARCHI/EMX/BIN"
ALLIANCE_TCSHDIR=ALLIANCE_BIN"/TCSH"
ALLIANCE_BASHDIR=ALLIANCE_BIN"/BASH"

PARSE ARG removeFlag

removeFlag="-rm"	/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
copyFromToolsBin="YES"

"md "REXX_ALLIANCE_BIN"\BASH 2>nul"
"md "REXX_ALLIANCE_BIN"\TCSH 2>nul"

IF removeFlag="-rm" then DO
	call SysFileTree REXX_ALLIANCE_BIN'\*.exe', 'datei', 'FO'
	do i=1 to datei.0
		"DEL "datei.i
	end
end

IF TRANSLATE(copyFromToolsBin)="YES" then DO
	copyFirst="YES"
	call SysFileTree REXX_ALLIANCE_TOOLS'\BIN', 'dir', 'SDO'
	do i=1 to dir.0
		call SysFileTree dir.i'\*', 'from_datei', 'FO'
		do j=1 to from_datei.0			
			a_out_name=WORD(TRANSLATE(FILESPEC("name",from_datei.j)," ","."),1)
			call SysFileTree REXX_ALLIANCE_BIN"\"a_out_name, 'to_datei', 'FO'
			IF (to_datei.0=0) & (a_out_name<>"INSTALLED") THEN DO
				IF copyFirst="YES" THEN
					SAY "Copying all files from tools/../bin to archi/../bin"
				"CP "from_datei.j" "REXX_ALLIANCE_BIN
				CALL CHAROUT ,a_out_name" "
				copyFirst="NO"
			end
		end
	end
end

call SysFileTree REXX_ALLIANCE_BIN'\*', 'datei', 'FO'
do i=1 to datei.0
	IF POS(".EXE",TRANSLATE(datei.i)) = 0 THEN
		CALL DoBind( datei.i removeFlag )
end
REM "CP e_dreal.cmd "REXX_ALLIANCE_BIN"\"
REM "CP e_graal.cmd "REXX_ALLIANCE_BIN"\"
REM "CP e_genview.cmd "REXX_ALLIANCE_BIN"\"
"CP "REXX_ALLIANCE_TOOLS"\dreal\archi\emx\bin\dreal.exe "REXX_ALLIANCE_BIN"\"
"CP "REXX_ALLIANCE_TOOLS"\graal\archi\emx\bin\graal.exe "REXX_ALLIANCE_BIN"\"
"RM sed.tmp"
return

/* ------------- Function : DoBind --------------- */

DoBind:

PARSE ARG PathAndName removeFlag

Name = FILESPEC("name",PathAndName)

"head -c 3 "PathAndName" > ExeHeader.tst"
call SysFileSearch "d", "ExeHeader.tst", found
"rm ExeHeader.tst"
IF found.0=1 THEN DO	/* Sollte a.out-Format sein */
	"EMXBIND -b -s -q "PathAndName
	"ECHO ********"Name": EXE ********"
	IF removeFlag = "-rm" THEN
		"RM "PathAndName
END
ELSE DO		/* Sollte tcsh, bash oder GenericGNg sein */
	"CP "PathAndName" "PathAndName".tmp"
	"echo s!/bin/rm!rm!g>sed.tmp"
	"echo s!/bin/chmod!chmod!>>sed.tmp"
	"echo s!/bin/echo!echo!>>sed.tmp"
	"echo s!/dev/null!nul!>> sed.tmp"
	"echo s/AWK=awk/AWK=gawk/>>sed.tmp"
	"echo s/^^$cc/$cc -Zexe/>>sed.tmp"

/* genlib */
	"echo s!^^$name;!cmd.exe /c $name.exe;!>> sed.tmp"
	"echo s!rm $name;!rm $name.exe $name;!>> sed.tmp"	
/* genpat */
 	"echo s!^^\( *\)$LOCAL_RES!\1cmd.exe /c $LOCAL_RES.exe!>> sed.tmp"
	"echo s!$RM -f $LOCAL_RES!$RM -f $LOCAL_RES.exe $LOCAL_RES!>> sed.tmp"
/* fpgen */
	"echo s/$RM -f $ROOT /$RM -f $ROOT.exe $ROOT />> sed.tmp"
	"echo s!$ROOT $ARGUMENTS!cmd.exe /c $ROOT.exe $ARGUMENTS!>> sed.tmp"
/* rest... */
/* not necessary ??? */
	"echo s!^^frin!cmd.exe /c frin.exe!>>sed.tmp"
	"echo s!^^frout!cmd.exe /c frout.exe!>>sed.tmp"
	"echo s!^^x2y!cmd.exe /c x2y.exe!>>sed.tmp"
	"echo s!^^vticheops!cmd.exe /c vticheops.exe!>>sed.tmp"

	"SED -f sed.tmp < "PathAndName".tmp > "PathAndName
	"RM "PathAndName".tmp"
	"HEAD -n1 "PathAndName" > FirstLine"
	CALL CheckAndAssembleDefineTmp( Name)
	"rm FirstLine"
	CALL BuildExe( PathAndName Name )
END
return

/* ------------- Function : CheckAndAssembleDefineTmp --------------- */

CheckAndAssembleDefineTmp:

PARSE ARG ExeName

	call SysFileSearch "GenericGNg", "FirstLine", found
	IF found.0=1 THEN DO
		"ECHO ********"ExeName": GenericGNg ********"
		'echo #define EXECSHELL "GenericGNg">define.tmp'
		IF removeFlag = "-rm" THEN
			"RM "PathAndName
	END
	ELSE DO
		call SysFileSearch "tcsh", "FirstLine", found
		IF found.0=1 THEN DO
			"ECHO ********"ExeName": tcsh ********"
			'echo #define EXECSHELL "tcsh">define.tmp'
			'echo #define EXPANDPATH "/TCSH">>define.tmp'
			"CP "PathAndName" "ALLIANCE_TCSHDIR"/"
			IF removeFlag = "-rm" THEN
				"RM "PathAndName
		END
		ELSE DO
			"ECHO ********"ExeName": bash ********"
			'echo #define EXECSHELL "bash">define.tmp'
			'echo #define EXPANDPATH "/BASH">>define.tmp'
			"CP "PathAndName" "ALLIANCE_BASHDIR"/"
			IF removeFlag = "-rm" THEN
				"RM "PathAndName
		END
	END
	'echo #define EXECNAME "'ExeName'">>define.tmp'
	IF DEBUGEXE="YES" THEN
		'echo #define DEBUG>>define.tmp'
return

/* ------------- Function : BuildExe --------------- */

BuildExe:

PARSE ARG ExePathAndName ExeName
	"cat define.tmp CFileBdy.c > CFile.c"
	"gcc -o "ExeName" -Zexe -Zomf -pipe  -I"EMX_INC" CFile.def CFile.c"
	"mv "ExeName".exe "ExePathAndName".exe"
	"rm CFile.c"	
	"rm "ExeName
	"rm define.tmp"
return