/* 
   Version 1.0							1996/11/30

   patch.cmd : This file is part of the alliance 3.0 patch for OS/2

   Copyright (C) 1996 Christoph Jaeschke, jaeschke@item.uni-bremen.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

"@echo off"
CALL RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
CALL SysLoadFuncs

reallydo="YES"			/* "NO" only shows what "YES" would really do */
BuildLexYac="NO"		/* "YES" rebuild the *.lex and *.yac files */
Debug="YES"			/* Include debugging information */
WITH_FREEMEM="YES"		/* ??? */
GRAAL_OMF="-Zomf -Zexe"		/* Parameters to add GCC in graal -> link with Link386 */
DREAL_OMF="-Zomf -Zexe"		/* Parameters to add GCC in graal -> link with Link386 */

/****************** nothing to edit below *********************/

PARSE ARG Par

CALL banner
SAY
IF WORDS(Par)<>2 then DO
	CALL syntax
	return
END
Par = TRANSLATE(Par)

IF LEFT(subword(Par,1,1),3)='X11' THEN DO
	IF Right(subword(Par,1,1),1)='+' THEN
		X11='YES'
				/* "YES" if you have the X11 lib's installed */
	ELSE
		X11='NO'
END
ELSE DO
	CALL syntax
	return
END
IF LEFT(subword(Par,2,1),7)='LESSTIF' THEN DO
	IF Right(subword(Par,2,1),1)='+' THEN
		LESSTIF='YES'
				/* "YES" if you have the MOTIF or LessTif lib's installed */
ELSE
		LESSTIF='NO'
END
ELSE DO
	CALL syntax
	return
END

SAY 'X11 = 'X11', LessTif = 'LESSTIF
SAY
REXX_TOP="\alliance"
REXX_MACHINE="emx"
COMPILE_DIR="archi/"REXX_MACHINE"/obj"
archi_inc="archi/"REXX_MACHINE"/include"
archi_lib="archi/"REXX_MACHINE"/lib"
patch_src="patch"
prol_src="prol"
sedFilesCnt=0

"cd \alliance"
CALL libchecks
SAY "Linking Directories:"
"md "REXX_TOP"\TMP 2>nul"
CALL MkDirs(REXX_TOP REXX_MACHINE)
CALL SysFileTree REXX_TOP"\tools\*" , 'tool', 'DO'
do i=1 to tool.0
	rc=CharOut( ,FILESPEC("name", tool.i)" ")
	CALL MkDirs(tool.i REXX_MACHINE) 
	"MD "tool.i"\archi\"REXX_MACHINE"\obj 2>nul"
	CALL CopyHierachy( tool.i"\sce" tool.i"\archi\"REXX_MACHINE"\obj")
END
rc=LINEOUT( ,"")
/* CALL prol */
CALL tutorials_makefiles
CALL genpat_script
CALL genview_cfiles
CALL pat_drv_bug_cfiles
CALL gds_parse_bug_cfiles
CALL set_signalmodel_EMX_cfiles
CALL function_getenv_cfiles
CALL rename_for_link_in_icons_cfiles
CALL fpgen_hfiles
CALL fpgen_mkfile
CALL fpgen_script
IF TRANSLATE(WITH_FREEMEM)<>"YES" THEN
	CALL tools_if_MACHINE_pc_emx
CALL tools_ifdef_pc_emx
CALL replacing_adding_files
/* CALL strncase_sub_in_lca2vbe_cfile -> substitute stricmp ist besser */
CALL stricmp_sub_in_lca2vbe_cfile
CALL def_file_change_lex_yac
CALL tools_makefiles
CALL edit_makefile_desb_inf
CALL edit_makefile_druc
CALL edit_makefile_tas
CALL edit_makefile_grog
CALL edit_makefile_s2r
/* CALL edit_makefile_mbkedif -> weil stricmp standard ist */
CALL edit_makefile_rds2ps
CALL edit_makefile_fpga
CALL edit_9x15_font_requests_hfiles
CALL edit_makefile_genview_gcc
CALL edit_makefile_genview
CALL edit_makefile_graal
CALL edit_makefile_dreal
CALL edit_makefile_netoptim
CALL edit_main_makefile
"rm sed.tmp"
"rm sed.log"
"cd "patch_src
exit

/*---------------- Procedures ------------------*/

banner:
	SAY "*****************************************************"
	SAY "*                                                   *"
	SAY "*  Alliance 3.0 patch for OS/2 (emx) architecture   *"
	SAY "*  Christoph Jaeschke, jaeschke@item.uni-bremen.de  *"
	SAY "*                                                   *"
	SAY "*****************************************************"
RETURN

libchecks:
   env = 'OS2ENVIRONMENT'
   x11root = VALUE('X11ROOT',,env)
   IF x11root = '' THEN DO
      SAY "Warning: The environment variable X11ROOT is not set."
      SAY "Warning: Looking at /."
      SAY
   END
   LessTifTree = x11root'\lesstif-current'
   XFree86Tree = x11root'\XFree86'
   
   IF exists(LessTifTree) THEN DO
      SAY "Assuming the LessTif tree is located at:"
      LessTifTree = TRANSLATE(LessTifTree, '/', '\')
      SAY '    'LessTifTree
      SAY 
   END
   ELSE	do
      SAY "LessTif tree NOT found at:"
      LessTifTree = TRANSLATE(LessTifTree, '/', '\')
      SAY '    'LessTifTree
      SAY 
      EXIT 1
   END
   
   IF exists(XFree86Tree) THEN DO
      SAY 
      SAY "Assuming the XFree86 tree is located at:"
      XFree86Tree = TRANSLATE(XFree86Tree, '/', '\')
      SAY '    'XFree86Tree
      SAY
   END
   ELSE	do
      SAY "XFree86 tree NOT found at:"
      XFree86Tree = TRANSLATE(XFree86Tree, '/', '\')
      SAY '    'XFree86Tree
      SAY 
      EXIT 1
   END
return

syntax:
	SAY 'Invocation syntax:'
	SAY 'PATCH.CMD x11+|- LESSTIF+|-		+ installed, - not installed'
return

prol:	
	"echo *** gunzip, untar, edit and compile prol files"
	"gzip -cd prol.tar.gz | tar -xvf -"
	"rm prol/prol"
	"echo w sed.log> sed.tmp"
	"echo 1i\>> sed.tmp"
	"echo SHELL=bash>> sed.tmp"
	"echo s/cc /gcc -Zexe />> sed.tmp"
	CALL BackupChangeWithSedTmp( "prol/Makefile" )
	"cd prol"
	"make | tee makeprol.log"
	"cd .."
	CALL CopyFromProl( "prol10.rds" "etc" )
	CALL CopyFromProl( "prol07.rds" "etc" )
return

genpat_script:
	"echo *** Substitute =$ALLIANCE_TMP for =/tmp, -lMut316 for -lMut315,"
	"echo *** Add -Zexe and .exe, removing /bin/ in genpat-script "
	"echo w sed.log> sed.tmp"
	"echo s!=/tmp!=$ALLIANCE_TMP!g>> sed.tmp"
	"echo s/awk/gawk/>> sed.tmp"
	"echo s/gcc/gcc -Zexe/>> sed.tmp"
	"echo s/-lMut315/-lMut316/>> sed.tmp"
	CALL ExpBackupChangeWithSedTmp( "genpat" "genpat" "genpat" )
return

genview_cfiles:
	"echo *** Substitute loc_sleep for sleep in genview/../v_colors.c "
	"echo w sed.log> sed.tmp"
	"echo s/sleep/loc_sleep/g>> sed.tmp"
	CALL ExpBackupChangeWithSedTmp( "genview" "@" "v_colors.c" )
return

pat_drv_bug_cfiles:
	"echo *** Remove bug: missing static before char* in pat/../ppt/pat_drvpat.c"
	"echo w sed.log> sed.tmp"
	"echo s/char *[*]signam/static char *signam/>> sed.tmp"
	CALL ExpBackupChangeWithSedTmp( "pat" "ppt" "pat_drvpat.c" )
return

gds_parse_bug_cfiles:
	"echo *** Remove bug: free on fixed char[33] in rdsgds/../gds_parse.c"
	"echo w sed.log> sed.tmp"
	"echo s!free(nom_modele);!/* free(nom_modele); */!>> sed.tmp"
	CALL ExpBackupChangeWithSedTmp( "rdsgds" "@" "gds_parse.c" )
return

set_signalmodel_EMX_cfiles:
	"echo *** Changing all re-signalings in handlers to signal(...,SIG_ACK), EMX-model"
	"echo w sed.log> sed.tmp"
	"echo  1,/^^unix_trap()/s/signal(\(.*\),.*)/signal(\1, SIG_ACK)/>> sed.tmp"
	CALL ExpBackupChangeWithSedTmp( "genview" "@" "d_interp_sig.c" )
	"echo w sed.log> sed.tmp"
	"echo  1,/signal(/s/signal(\(.*\),.*)/signal(\1, SIG_ACK)/>> sed.tmp"
	CALL ExpBackupChangeWithSedTmp( "graal" "@" "GMX_view.c" )	
	"echo w sed.log> sed.tmp"
	"echo  1,/signal(/s/signal(.*,\(.*\))/signal( SIGTERM, SIG_ACK); signal(SIGTERM, \1)/>> sed.tmp"
	CALL ExpBackupChangeWithSedTmp( "graal" "@" "GRM_mbkrds.c" )
	"echo w sed.log> sed.tmp"
	"echo  1,/signal(/s/signal(\(.*\),.*)/signal(\1, SIG_ACK)/>> sed.tmp"
	CALL ExpBackupChangeWithSedTmp( "dreal" "@" "GMX_view.c" )
	"echo w sed.log> sed.tmp"
	"echo  1,/signal(/s/signal(.*,\(.*\))/signal( SIGTERM, SIG_ACK); signal(SIGTERM, \1)/>> sed.tmp"
	CALL ExpBackupChangeWithSedTmp( "dreal" "@" "GRD_rds.c" )
return

function_getenv_cfiles:
	"echo *** Substitute getenv() for /usr/tmp, nul for /dev/null"
	"echo *** in 7 graal/dreal/genview/tas c-files"
	"echo w sed.log> sed.tmp"
	"echo s!/dev/null!nul!g>> sed.tmp"
	CALL ExpBackupChangeWithSedTmp( "tas" "tas" "tas_util.c" )
	'echo s#sprintf\(.*\)"/usr/tmp\([^^,]*\),#sprintf\1"%%s\2,((getenv("ALLIANCE_TMP")!=NULL)?getenv("ALLIANCE_TMP"):""),#>> sed.tmp'
	CALL ExpBackupChangeWithSedTmp( "graal" "@" "GRM_error.c" )
	CALL ExpBackupChangeWithSedTmp( "dreal" "@" "GRD_error.c" )
	CALL ExpBackupChangeWithSedTmp( "genview" "@" "t_rl.pwet.c" )
	CALL ExpBackupChangeWithSedTmp( "genview" "@" "t_rl.c" )
	"echo s#sprintf\(.*\)/usr/tmp#sprintf\1%%s#>> sed.tmp"
	'echo s/E_LoadStr, *getpid()/E_LoadStr, ((getenv("ALLIANCE_TMP")!=NULL)?getenv("ALLIANCE_TMP"):""), getpid()/>> sed.tmp'
	CALL ExpBackupChangeWithSedTmp( "genview" "@" "e_win.c" )
	"echo w sed.log> sed.tmp"
	'echo s/getenv *("TMPDIR")/getenv ("ALLIANCE_TMP")/>> sed.tmp'
	CALL ExpBackupChangeWithSedTmp( "genview" "gcc-1.42" "gcc.c" )
return

rename_for_link_in_icons_cfiles:
	"echo *** Substitute rename() for link/unlink-Seq. in  ai/icn-drive.c "
	"echo w sed.log> sed.tmp"
	"echo /if *( *link( *filename *, *buf *)/i\>> sed.tmp"
	"echo #ifdef __EMX__\>> sed.tmp"
	"echo 		rename(filename, buf);\>> sed.tmp"
	"echo #else>> sed.tmp"
	"echo /unlink( *filename *)/a\>> sed.tmp"
	"echo #endif>> sed.tmp"
	CALL ExpBackupChangeWithSedTmp( "icones" "@" "aidrive.c" ) 
	CALL ExpBackupChangeWithSedTmp( "icones" "@" "icndrive.c" ) 
return

fpgen_hfiles:
	"echo *** Substitute va_list for ( ... ) in FpGen/FpGenMGN.h "
	"echo w sed.log> sed.tmp"
	"echo s/\(extern.*\)(( *[.][.][.] *))\(.*\)/\1(( va_alist ))\2/>> sed.tmp"
	CALL ExpBackupChangeWithSedTmp( "fitpath" "FpGen" "fpgenmgn.h" ) 
return

fpgen_mkfile:
	"echo *** Delete -s from fitpath.mk, because ld stripping is buggy"
	"echo w sed.log> sed.tmp"
	"echo s/-s / />> sed.tmp"
	CALL ExpBackupChangeWithSedTmp( "fitpath" "@" "fitpath.mk" ) 
return

fpgen_script:
	"echo *** Substitute gawk for awk in FpGen/B.fpgen.(c)sh "
	"echo w sed.log> sed.tmp"
	"echo s/awk/gawk/>> sed.tmp"
	"echo s/$CC/$CC -Zexe/>> sed.tmp"
	CALL ExpBackupChangeWithSedTmp( "fitpath" "FpGen" "B.fpgen.sh" ) 
	/* csh-script was not generated 
		"echo s/${CC}/${CC} -Zexe/>> sed.tmp"
		"echo s/${RM} -f ${argv[$NAMEARG]}/$RM -f ${argv[$NAMEARG]}.exe/>> sed.tmp"
		CALL ExpBackupChangeWithSedTmp( "fitpath" "FpGen" "B.fpgen.csh" ) 
	*/
return

replacing_adding_files:
	"CP "PATCH_SRC"/emx.mk.head "PATCH_SRC"/emx.tmp"
	"echo X11_BIN          = "XFree86Tree"/bin >> "PATCH_SRC"/emx.tmp"
	"echo X11_LIB          = "XFree86Tree"/lib >> "PATCH_SRC"/emx.tmp"
	"echo X11_INCLUDE      = "XFree86Tree"/include >> "PATCH_SRC"/emx.tmp"
	"echo MOTIF_BIN        = "LessTifTree"/bin >> "PATCH_SRC"/emx.tmp"
	"echo MOTIF_LIB        = "LessTifTree"/lib >> "PATCH_SRC"/emx.tmp"
	"echo MOTIF_INCLUDE    = "LessTifTree"/include >> "PATCH_SRC"/emx.tmp"
	IF TRANSLATE(Debug)="YES" THEN DO
		"echo STRIP		= $(TOUCH) >> "PATCH_SRC"/emx.tmp"
		"echo CFLAGS		= -pipe -static -g >> "PATCH_SRC"/emx.tmp"
		"echo X11CFLAGS		= -pipe -g >> "PATCH_SRC"/emx.tmp"
		"echo *** Adding emx.mk (-g) in etc/"
	END
	ELSE DO
		"echo STRIP		= strip +strip-debug >> "PATCH_SRC"/emx.tmp"
		"echo CFLAGS		= -pipe -static >> "PATCH_SRC"/emx.tmp"
		"echo X11CFLAGS		= -pipe >> "PATCH_SRC"/emx.tmp"
		"echo *** Adding emx.mk (strip-debug) in etc/ "
	END
	"CAT "PATCH_SRC"/emx.tmp "PATCH_SRC"/emx.mk.trail > "PATCH_SRC"/emx.mk"
	CALL CopyFromPatch( "emx.mk" "etc/")
 	"RM "PATCH_SRC"/emx.tmp"
	"RM "PATCH_SRC"/emx.mk"
	"echo *** Adding values.h to archi/emx/include "
	CALL CopyFromPatch( "values.h" archi_inc"/")
return

/*
strncase_sub_in_lca2vbe_cfile:
	"echo *** Substitute strncasecmp( , ,INT_MAX) for strcasecmp() in fpga/.../lca2vbe.c "
	"echo w sed.log> sed.tmp"
	"echo /^^#include/i\>> sed.tmp"
	"echo #include ^<limits.h^>>> sed.tmp"
	"echo s/strcasecmp(\([^^,]*,[^^)]*\)\(.*\)/strncasecmp(\1,INT_MAX\2/>> sed.tmp"
	CALL ExpBackupChangeWithSedTmp( "fpga" "lca_vbe" "lca2vbe.c" ) 
return
*/

stricmp_sub_in_lca2vbe_cfile:
	"echo *** Substitute stricmp for strcasecmp() in fpga/.../lca2vbe.c "
	"echo w sed.log> sed.tmp"
	"echo s/strcasecmp/stricmp/>> sed.tmp"
	CALL ExpBackupChangeWithSedTmp( "fpga" "lca_vbe" "lca2vbe.c" )
return

edit_9x15_font_requests_hfiles:
	"echo *** Changing 9x15 fonts to 7x13 in genview/v_drv.h, dreal ^& graal/GMX_color.h..."
	"echo w sed.log> sed.tmp"
	"echo s/9x15/7x13/>> sed.tmp"
	CALL ExpBackupChangeWithSedTmp( "genview" "@" "v_drv.h" )
	CALL ExpBackupChangeWithSedTmp( "dreal" "@" "GMX_color.h" )
	CALL ExpBackupChangeWithSedTmp( "graal" "@" "GMX_color.h" )
return

def_file_change_lex_yac:
	"echo *** Collecting all Lexer and Parsersources, changing _FILE to xyz_FILE,"
	"echo *** Substitute strnicmp for strncasecmp()..."
	"echo w sed.log> sed.tmp"
	"echo s/\(addhtitem.*[^^z]\)_FILE\(.*$\)/\1xyz_FILE\2/>> sed.tmp"
	'echo s/\("file".*[^^z]\)_FILE\(.*$\)/\1xyz_FILE\2/>> sed.tmp'
	CALL MaskBackupChangeWithSedTmp( "tools"  "*.lex" )
	"echo w sed.log> sed.tmp"
	"echo s/\(%token.*[^^z]\)_FILE$/\1xyz_FILE/>> sed.tmp"
	"echo s/strncasecmp/strnicmp/>> sed.tmp"
	CALL MaskBackupChangeWithSedTmp( "tools"  "*.yac" )
	IF TRANSLATE(BuildLexYac) <> "YES" THEN DO
		"echo *** Copy all lex.yy.c to lexyy.c "
		CALL MaskCopy("lex.yy.c" "lexyy.c")
		"echo *** Collecting all lexyy.c, y.tab.c ^& y.tab.h, changing _FILE to xyz_FILE "
		"echo w sed.log> sed.tmp"
		"echo /addhtitem/s/\([^^z]\)_FILE/\1xyz_FILE/>> sed.tmp"
		"echo /^^#define._FILE/s/\([^^z]\)_FILE/\1xyz_FILE/>> sed.tmp"
		'echo s/"_FILE"/"xyz_FILE"/>> sed.tmp'
		CALL MaskBackupChangeWithSedTmp( "tools" "y.tab.c" )
		CALL MaskBackupChangeWithSedTmp( "tools" "y.tab.h" )
		CALL MaskBackupChangeWithSedTmp( "tools"  "lexyy.c" )
	END
return

tools_makefiles:
	"echo *** Cutting lib-prefixes, insert MACHINE/TOP, substitute mv/cat for cat ^>^> "
	"echo w sed.log> sed.tmp"
	"echo /include.*$(MACHINE)[.]mk/s/.*//>> sed.tmp"
	"echo s/lib\([a-zA-Z0-9]\{1,8\}[.]a\)/\1/>> sed.tmp"
	"echo s/lib\([a-zA-Z0-9]\{1,8\}$(.*)[.]a\)/\1/>> sed.tmp"
	"echo s/lib\([a-zA-Z0-9]\{1,8\}${.*}[.]a\)/\1/>> sed.tmp"
	"echo s/lex[.]yy/lexyy/g>> sed.tmp"
	"echo /(CAT).*^>^>.*; *[\]/s/(CAT) *\([^^ ]*\) *^>^> *\([^^;]*\)/(MV) \2 tmp.file; $(CAT) tmp.file \1 ^> \2/>> sed.tmp"
	"echo /cat .*^>^>.*; *[\]/s/cat *\([^^ ]*\) *^>^> *\([^^;]*\)/$(MV) \2 tmp.file; cat tmp.file \1 ^> \2/>> sed.tmp"
	IF TRANSLATE(BuildLexYac) = "YES" THEN DO
		"echo *** and removing lex/yac #'s  "
		"echo /^^clean *:/,/^^$/{>> sed.tmp"
		"echo /$(RM)/s/^^#//>> sed.tmp"
		"echo }>> sed.tmp"
		"echo /^^#.*lexyy[.]c *[:]/,/^^$/s/^^#//>> sed.tmp"
		"echo /^^#.*y[.]tab[.]c *[:]/,/^^$/s/^^#//>> sed.tmp"
	END
	CALL BackupChangeWithSedTmp( "etc/libraries.mk" )
	"echo *** in Makefiles..."
	"echo 1i\>> sed.tmp"
	"echo TOP=/alliance\>> sed.tmp"
	"echo MACHINE=emx\>> sed.tmp"
	"echo include $(TOP)/etc/$(MACHINE).mk>> sed.tmp"
	"echo s!/bin/chmod!chmod!>> sed.tmp"
	"echo s!/bin/rm!rm!>> sed.tmp"
	"echo s!/bin/echo!echo!>> sed.tmp"
	"echo s!/dev/null!nul!>> sed.tmp"
	"echo s!/bin/nroff!nroff!>> sed.tmp"
	"echo s!/bin/sh!bash!>> sed.tmp"
	"echo s/-DMACHINE=$(MACHINE)/-D$(MACHINE)/>> sed.tmp"
/*	"echo s/-D$(MACHINE)/-D$(MACHINE) -Dpc/>> sed.tmp" */
	"echo s/MACHINE=$(MACHINE)//>> sed.tmp"
	"echo s/TOP=$(TOP)//>> sed.tmp"
	CALL MaskBackupChangeWithSedTmp( "tools"  "Makefile" )
	CALL BackupChangeWithSedTmp( "Makefile" )
return

tools_ifdef_pc_emx:
	"echo *** Changing #if(n)def pc to emx in flop, genview, mbkal, s2r"
	"echo w sed.log> sed.tmp"
	"echo /^^#.*def.*pc/s/pc/emx/>> sed.tmp"
	CALL ExpBackupChangeWithSedTmp( "flop" "@" "check.c" )
	CALL ExpBackupChangeWithSedTmp( "flop" "@" "old_check.c" )
	CALL ExpBackupChangeWithSedTmp( "flop" "@" "util.c" )
	CALL ExpBackupChangeWithSedTmp( "genview" "gcc-1.42" "c-parse.tab.c" )
	CALL ExpBackupChangeWithSedTmp( "genview" "@" "d_exec.c" )
	CALL ExpBackupChangeWithSedTmp( "genview" "@" "d_interp_fonc.c" )
	CALL ExpBackupChangeWithSedTmp( "genview" "@" "d_stdlib.c" )
	CALL ExpBackupChangeWithSedTmp( "mbkal" "@" "generic_target.h" )
	CALL ExpBackupChangeWithSedTmp( "s2r" "@" "generic.h" )
return

tools_if_MACHINE_pc_emx:
	"echo *** Changing #if MACHINE ... pc to emx in fpga, netoptim, proof, sl"
	"echo w sed.log> sed.tmp"
	"echo /^^#if MACHINE.*pc/s/ pc/ emx/>> sed.tmp"
	CALL ExpBackupChangeWithSedTmp( "fpga" "compil" "sl_compile.c" )
	CALL ExpBackupChangeWithSedTmp( "fpga" "compil" "sl_util.c" )
	CALL ExpBackupChangeWithSedTmp( "fpga" "fpmenu" "fp_menu.c" )
	CALL ExpBackupChangeWithSedTmp( "fpga" "mapping" "compile.c" )
	CALL ExpBackupChangeWithSedTmp( "fpga" "mapping" "generic.c" )
	CALL ExpBackupChangeWithSedTmp( "fpga" "mapping" "regles.c" )
	CALL ExpBackupChangeWithSedTmp( "fpga" "mapping" "util.c" )
	CALL ExpBackupChangeWithSedTmp( "fpga" "param" "sl_param.c" )
	CALL ExpBackupChangeWithSedTmp( "netoptim" "compil" "sl_compile.c" )
	CALL ExpBackupChangeWithSedTmp( "netoptim" "compil" "sl_util.c" )
	CALL ExpBackupChangeWithSedTmp( "netoptim" "load" "neto.c" )
	CALL ExpBackupChangeWithSedTmp( "netoptim" "load" "no_optim.c" )
	CALL ExpBackupChangeWithSedTmp( "netoptim" "load" "util.c" )
	CALL ExpBackupChangeWithSedTmp( "netoptim" "mapping" "generic.c" )
	CALL ExpBackupChangeWithSedTmp( "netoptim" "netmenu" "no_menu.c" )
	CALL ExpBackupChangeWithSedTmp( "proof" "compil" "sl_compile.c" )
	CALL ExpBackupChangeWithSedTmp( "proof" "compil" "sl_util.c" )
	CALL ExpBackupChangeWithSedTmp( "sl" "compil" "sl_compile.c" )
	CALL ExpBackupChangeWithSedTmp( "sl" "compil" "sl_util.c" )
	CALL ExpBackupChangeWithSedTmp( "sl" "mapping" "compile.c" )
	CALL ExpBackupChangeWithSedTmp( "sl" "mapping" "generic.c" )
	CALL ExpBackupChangeWithSedTmp( "sl" "mapping" "regles.c" )
	CALL ExpBackupChangeWithSedTmp( "sl" "mapping" "util.c" )
	CALL ExpBackupChangeWithSedTmp( "sl" "mbk" "sl_mbk.c" )
	CALL ExpBackupChangeWithSedTmp( "sl" "menu" "sl_corps.c" )
	CALL ExpBackupChangeWithSedTmp( "sl" "param" "sl_param.c" )
return

edit_makefile_druc:
	"echo *** Changing drucompi.c/h to _c.c/h in Makefile and copy files in druc..."
	"echo w sed.log> sed.tmp"
	"echo s/drucompi[.]\([cho]\)/drucompi_c.\1/g>> sed.tmp"
	CALL ExpEditMakefileWithSedTmp( "druc" "@" )
	CALL ExpCopy( "drucompi.c" "drucompi_c.c" "druc" "@" )
	CALL ExpCopy( "drucompi.h" "drucompi_c.h" "druc" "@" )
	"echo w sed.log> sed.tmp"
	'echo /#include *"drucompi.h"/s/drucompi/drucompi_c/g>> sed.tmp'
	CALL ExpBackupChangeWithSedTmp( "druc" "@" "drucompi_c.c" )
return

edit_makefile_desb_inf:
	"echo *** Changing inf.c to inf_c.c in Makefile and copy files in desb/inf..."
	"echo w sed.log> sed.tmp"
	"echo s/inf[.]o/inf_c.o/g>> sed.tmp"
	"echo s/inf[.]yy/inf_yy/g>> sed.tmp"
	CALL ExpCopy( "inf.c" "inf_c.c" "desb" "inf" )
	CALL ExpEditMakefileWithSedTmp( "desb" "inf" )
return

edit_makefile_tas:
	"echo *** Changing default-technology to /etc/prol10.elp in Makefile tas..."
	"echo w sed.log> sed.tmp"
	"echo s!/etc/ecpd10.elp!/etc/prol10.elp!>> sed.tmp"
	CALL ExpEditMakefileWithSedTmp( "tas" "tas" )
return

edit_makefile_grog:
	"echo *** Changing Makefile grog, adding lib-bsd entry ..."
	"echo w sed.log> sed.tmp"
	"echo s/ *-lm/ -lm -lbsd/>> sed.tmp"
	CALL ExpEditMakefileWithSedTmp( "grog" "@" )
return

edit_makefile_s2r:
	"echo *** Removing s2rps.o Target from Makefile s2r (rusage not implemented)..."
	"echo w sed.log> sed.tmp"
	"echo /OBJECTS.*=.*s2rps.o/s/s2rps.o//>> sed.tmp"
	CALL ExpEditMakefileWithSedTmp( "s2r"  "@" )
return

edit_makefile_mbkedif:
	"echo *** Adding strncase.o to library-target in tools/mbkedif/../Makefile "
	"echo w sed.log> sed.tmp"
	"echo s/LOCAL_OBJ *=.*/^& strncase.o/>> sed.tmp"
	"echo /^^clean *:/i\>> sed.tmp"
	"echo strncase.o : strncase.c\>> sed.tmp"
	"echo \	$(CC) $(LOCAL_CFLAGS) -c strncase.c\>> sed.tmp"
	"echo \>> sed.tmp"
	CALL ExpEditMakefileWithSedTmp( "mbkedif" "@" )
return

edit_makefile_rds2ps:
	apostr="'"
	SEDTMP="sed.tmp"
	"echo *** Changing Makefile rds2ps due to awk problems ..."
	"echo w sed.log> sed.tmp"
	rc=LINEOUT(SEDTMP, "s/>> tmp_dict.c/> tmp.1; cat tmp_dict.c tmp.1 > tmp.2;mv tmp.2 tmp_dict.c; rm tmp.1/")
	rc=LINEOUT(SEDTMP, "s!/usr/bin/nroff!groff!")
	rc=LINEOUT(SEDTMP, "s!/usrnroff!groff!")
	rc=LINEOUT(SEDTMP, '/^tmp_man.o/,/$(CC).*tmp_man.c/s/[\]"/%c/g')
	rc=LINEOUT(SEDTMP, '/^tmp_man.o/,/$(CC).*tmp_man.c/s/[\][\]/\\\\\\/g')
	rc=LINEOUT(SEDTMP, '/^tmp_man.o/,/$(CC).*tmp_man.c/s/$$0/34, \\$$0, 34 /g')
	rc=LINEOUT(SEDTMP, '/^tmp_man.o/,/$(CC).*tmp_man.c/s/\([^\]\)"/\1\\"/g')
	rc=LINEOUT(SEDTMP, '/^tmp_man.o/,/$(CC).*tmp_man.c/s/'apostr'/"/g')
	rc=LINEOUT(SEDTMP, '/^tmp_dict.o/,/$(CC).*tmp_dict.c/s/[\]"/%c/g')
	rc=LINEOUT(SEDTMP, '/^tmp_dict.o/,/$(CC).*tmp_dict.c/s/[\][\]/\\\\\\/g')
	rc=LINEOUT(SEDTMP, '/^tmp_dict.o/,/$(CC).*tmp_dict.c/s/$$0/34, \\$$0, 34 /g')
	rc=LINEOUT(SEDTMP, '/^tmp_dict.o/,/$(CC).*tmp_dict.c/s/\([^\]\)"/\1\\"/g')
	rc=LINEOUT(SEDTMP, '/^tmp_dict.o/,/$(CC).*tmp_dict.c/s/'apostr'/"/g')
	rc=LINEOUT(SEDTMP)
	CALL ExpEditMakefileWithSedTmp( "rds2ps" "@" )
return

edit_makefile_fpga:
	"echo *** Changing Makefile fpga: Substitute errornous ../.. to .."
	"echo w sed.log> sed.tmp"
	"echo s![.][.]/[.][.]!..!g>> sed.tmp"
	CALL ExpEditMakefileWithSedTmp( "fpga" "@" )
return

edit_makefile_genview_gcc:
	"echo *** Changing Makefile genview/../gcc-1.42: Adding -Zexe ^& bash ..."
	"echo w sed.log> sed.tmp"
	"echo s!$(srcdir)/move-if-change tmp!bash $(srcdir)/move-if-change tmp!>> sed.tmp"
	"echo /^^genconfig *:/,$s/$(CFLAGS)/$(CFLAGS) -Zexe/>> sed.tmp"
	CALL ExpEditMakefileWithSedTmp( "genview" "gcc-1.42" )
return

edit_makefile_genview:
	"echo *** Changing Makefile genview: Adding -L$(X11_LIB), -Zmtd, removing -static..."
	"echo w sed.log> sed.tmp"
	"echo s/-O3/-O3 -g/>> sed.tmp"
	"echo /$(MV) genview watchdog/i\>> sed.tmp"
	"echo \	$(STRIP) genview \>> sed.tmp"
	"echo \	$(STRIP) watchdog>> sed.tmp"
	"echo /^^genview *:/,/^^grog_genview *:/s/$(CFLAGS)/-Zmtd $(X11CFLAGS)/>> sed.tmp"
	"echo /-o watchdog/s/-lX11/-L$(X11_LIB) -lX11/>> sed.tmp"
	CALL ExpEditMakefileWithSedTmp( "genview" "@" )
return

edit_makefile_graal:
	"echo *** Changing Makefile graal: Adding -Zmtd "GRAAL_OMF" -L/-I$(MOTIF), removing -static..."
	"echo w sed.log> sed.tmp"
	"echo s/$(CFLAGS)/$(CFLAGS) "GRAAL_OMF"/>> sed.tmp"
	"echo s/-L$(X11_LIB)/-L$(X11_LIB) -L$(MOTIF_LIB)/>> sed.tmp"
	"echo s/-I$(X11_INCLUDE)/-I$(X11_INCLUDE) -I$(MOTIF_INCLUDE)/>> sed.tmp"
	"echo /^^graal *:/,/^^graal.o *:/s/$(LOCAL_CFLAGS)/-Zmtd "GRAAL_OMF" $(X11CFLAGS)/>> sed.tmp"
	IF POS('-Zomf', GRAAL_OMF) > 0 THEN DO
		"echo s/[.]o/.obj/g>> sed.tmp"
		"echo /$(STRIP) *graal/d>> sed.tmp"
		"echo s!$(MV) *graal *[.][.]/bin/graal!$(MV) graal.exe ../bin/!>> sed.tmp"
	END
	CALL ExpEditMakefileWithSedTmp( "graal" "@" )
return

edit_makefile_dreal:
	"echo *** Changing Makefile dreal: Adding -Zmtd "DREAL_OMF" L/-I$(MOTIF), removing -static..."
	"echo w sed.log> sed.tmp"
	"echo s/$(CFLAGS)/$(CFLAGS) "DREAL_OMF"/>> sed.tmp"
	"echo s/-L$(X11_LIB)/-L$(X11_LIB) -L$(MOTIF_LIB)/>> sed.tmp"
	"echo s/-I$(X11_INCLUDE)/-I$(X11_INCLUDE) -I$(MOTIF_INCLUDE)/>> sed.tmp"
	"echo /^^dreal *:/,/^^dreal.o *:/s/$(LOCAL_CFLAGS)/-Zmtd "DREAL_OMF" $(X11CFLAGS)/>> sed.tmp"
	IF POS('-Zomf', DREAL_OMF) > 0 THEN DO
		"echo s/[.]o/.obj/g>> sed.tmp"
		"echo /$(STRIP) *dreal/d>> sed.tmp"
		"echo s!$(MV) *dreal *[.][.]/bin/dreal!$(MV) dreal.exe ../bin/!>> sed.tmp"
	END
	CALL ExpEditMakefileWithSedTmp( "dreal" "@" )
return

edit_makefile_netoptim:
	"echo *** Changing Makefile netoptim: Adding -g for load/util.c compile"
	"echo w sed.log> sed.tmp"
	"echo /$(CC).*load.util.c/s/$(LOCAL_CFLAGS)/$(LOCAL_CFLAGS) -g/>> sed.tmp"
	CALL ExpEditMakefileWithSedTmp( "netoptim" "@" )
return


edit_main_makefile:
	"echo w sed.log> sed.tmp"
	"echo s!archi/$(MACHINE)/obj!"COMPILE_DIR"!g>> sed.tmp"
	"echo s/ $(RANLIB) $$i ;/ $(RANLIB) $$i ; $(EMXOMF) $$i ; />> sed.tmp"
	IF TRANSLATE(LESSTIF) = "NO" THEN DO
		"echo /^^all *:/,/:/s/install-graal/             />> sed.tmp"
		"echo /^^all *:/,/:/s/install-dreal/             />> sed.tmp"
		"echo /^^clean-tools *:/,/:/s/clean-graal/           />> sed.tmp"
		"echo /^^clean-tools *:/,/:/s/clean-dreal/           />> sed.tmp"
		MainMakefileRemoveInstall="install-graal, install-dreal"
		MainMakefileRemoveClean="clean-graal, clean-dreal"
		X11="YES"
	END 
	ELSE DO
		MainMakefileRemoveInstall="nothing"
		MainMakefileRemoveClean="nothing"
	END
	IF TRANSLATE(X11) = "NO" THEN DO
		"echo /^^all *:/,/:/s/install-genview/               />> sed.tmp"
		"echo /^^clean-tools *:/,/:/s/clean-genview/             />> sed.tmp"
		MainMakefileRemoveInstall=MainMakefileRemoveInstall", install-genview"
		MainMakefileRemoveClean=MainMakefileRemoveClean", clean-genview"
	END
	"echo *** Removing "MainMakefileRemoveInstall" from Main-Makefile..."
	"echo /^^all *:/i\>> sed.tmp"
	"echo # Removed "MainMakefileRemoveInstall"\>> sed.tmp"
	"echo \ >> sed.tmp"
	"echo /^^clean-tools *:/i\>> sed.tmp"
	"echo # Removed "MainMakefileRemoveClean"\>> sed.tmp"
	"echo \ >> sed.tmp"
	"echo s/$(RM) -f $(ALLIANCE_BIN)/$(RM) -rf $(ALLIANCE_BIN)/>> sed.tmp"
	CALL EditFileWithSedTmp( "Makefile" )
return

tutorials_makefiles:
	"echo *** Changing Tutorial-Makefiles, Adding Top, Machine and include emx.mk,"
	"echo *** removing SHELL="
/*
	, switching to cmos_5.rds"
*/
	"echo w sed.log> sed.tmp"
	"echo 1i\>> sed.tmp"
	"echo TOP=/alliance\>> sed.tmp"
	"echo MACHINE=emx\>> sed.tmp"
	"echo include $(TOP)/etc/$(MACHINE).mk>> sed.tmp"
	"echo /SHELL *=/d>> sed.tmp"
	"echo /TOP *=/d>> sed.tmp"
	"echo s!dplib/ecpd10!dplib!>> sed.tmp"
	"echo s!bin/rm!rm!>> sed.tmp"
	"echo s!dev/null!nul!>> sed.tmp"
/*
	"echo s!prol10!cmos_5!>> sed.tmp"
*/
	"echo s!ALLIANCE_BIN *=.*!ALLIANCE_BIN = $(TOP)/archi/$(MACHINE)/bin!>> sed.tmp"
	"echo s!FITPATH_BIN *=.*!FITPATH_BIN = $(TOP)/archi/$(MACHINE)/bin!>> sed.tmp"
	"echo s!USER_BIN *=.*!USER_BIN = $(TOP)/archi/$(MACHINE)/bin!>> sed.tmp"
	"echo s!DPR_BIN *=.*!DPR_BIN = $(TOP)/archi/$(MACHINE)/bin!>> sed.tmp"
	CALL BackupChangeInTutorialsWithSedTmp
return

/*---------------- expand full path of the named tool ------------------*/

ExpObj:
PARSE ARG tool level2

IF level2="@" THEN
	RETVAL="tools/"tool"/archi/emx/obj"
ELSE
	RETVAL="tools/"tool"/archi/emx/obj/"level2
RETURN RETVAL

/*---------------- edit a changed Makefile with sed.tmp ------------------*/

ExpEditMakefileWithSedTmp:
PARSE ARG tool level2

ExpPath=ExpObj( tool  level2)
CALL EditfileWithSedTmp( ExpPath"/Makefile" )
RETURN

EditFileWithSedTmp:
PARSE ARG ExpandedPathfile

IF reallydo = "YES" THEN DO
	"CP "ExpandedPathFile" "ExpandedPathFile".tmp"
	"SED -f sed.tmp  < "ExpandedPathFile".tmp > "ExpandedPathFile
	"RM "ExpandedPathFile".tmp"
END
ELSE DO
	SAY "CP "ExpandedPathFile" "ExpandedPathFile".tmp"
	SAY"SED -f sed.tmp  < "ExpandedPathFile".tmp > "ExpandedPathFile
	SAY "RM "ExpandedPathFile".tmp"
END
RETURN

/*---------------- copy from patch-dir to expanded tool-path ------------------*/

ExpCopyFromPatch:
PARSE ARG file tool level2

IF reallydo = "YES" THEN
	"CP "PATCH_SRC"/"file" "ExpObj( tool  level2)"/"
ELSE
	SAY "CP "PATCH_SRC"/"file" "ExpObj( tool  level2)"/"
RETURN

/*---------------- copy fromfile tofile in expanded tool-path ------------------*/

ExpCopy:
PARSE ARG fromfile tofile tool level2

IF reallydo = "YES" THEN
	"CP "ExpObj( tool  level2)"/"fromfile" "ExpObj( tool  level2)"/"tofile
ELSE
	SAY "CP "ExpObj( tool  level2)"/"fromfile" "ExpObj( tool  level2)"/"tofile
RETURN

/*---------------- Copy from patch-dir to path ------------------*/

CopyFromPatch:
PARSE ARG file pfad

IF reallydo = "YES" THEN
	"CP "PATCH_SRC"/"file" "pfad
ELSE
	SAY "CP "PATCH_SRC"/"file" "pfad
RETURN

/*---------------- Copy from prol-dir to path ------------------*/

CopyFromProl:
PARSE ARG file pfad

IF reallydo = "YES" THEN
	"CP "PROL_SRC"/"file" "pfad
ELSE
	SAY "CP "PROL_SRC"/"file" "pfad
RETURN

/*---------------- copy of files with mask-critera (sed.tmp) ------------------*/

MaskCopy:
PARSE ARG fromFile toFile

CALL SysFileTree "tools\"fromFile, 'file', 'FSO'

do i=1 to file.0
   InCompileDir = POS(TRANSLATE(TRANSLATE(COMPILE_DIR,"\","/")), TRANSLATE(file.i))
   IF InCompileDir > 1 THEN DO
	IF reallydo = "YES" THEN
		"CP "file.i" "FILESPEC("drive", file.i)""FILESPEC("path", file.i)""toFile
	ELSE
		SAY "CP "file.i" "FILESPEC("drive", file.i)""FILESPEC("path", file.i)""toFile
   END
end
RETURN

/*---------------- backup and change of files with mask-criteria (sed.tmp) ------------------*/

MaskBackupChangeWithSedTmp:
PARSE ARG dir Mask

CALL SysFileTree dir'\'Mask, 'file', 'FSO'

do i=1 to file.0
   InCompileDir = POS(TRANSLATE(TRANSLATE(COMPILE_DIR,"\","/")), TRANSLATE(file.i))
   IF InCompileDir > 1 THEN DO
	CALL checkAllSedChangedFiles(file.i)
	IF reallydo = "YES" THEN DO
		"IF NOT EXIST "file.i".org CP "file.i" "file.i".org"
		"SED -f sed.tmp  < "file.i".org > "file.i
	END
	ELSE DO
		SAY "IF NOT EXIST "file.i".org CP "file.i" "file.i".org"
		SAY "SED -f sed.tmp  < "file.i".org > "file.i
	END
   END
end
RETURN


/*---------------- backup and change of Makefiles in dir tutorials ------------------*/

BackupChangeInTutorialsWithSedTmp:

CALL SysFileTree 'tutorials\Makefile', 'file', 'FSO'

do i=1 to file.0
	CALL checkAllSedChangedFiles(file.i)
	IF reallydo = "YES" THEN DO
		"IF NOT EXIST "file.i".org CP "file.i" "file.i".org"
		"SED -f sed.tmp  < "file.i".org > "file.i
	END
	ELSE DO
		SAY "IF NOT EXIST "file.i".org CP "file.i" "file.i".org"
		SAY "SED -f sed.tmp  < "file.i".org > "file.i
	END
end
RETURN


/*---------------- backup and change of a file with sed.tmp ------------------*/

ExpBackupChangeWithSedTmp:
PARSE ARG tool level2 file

ExpPath=ExpObj(tool level2)
CALL BackupChangeWithSedTmp( ExpPath"/"file )
RETURN

BackupChangeWithSedTmp:
PARSE ARG ExpandedPathFile

CALL checkAllSedChangedFiles(ExpandedPathFile)
IF reallydo = "YES" THEN DO
	"IF NOT EXIST "ExpandedPathFile".org CP "ExpandedPathFile" "ExpandedPathFile".org"
	"SED -f sed.tmp  < "ExpandedPathFile".org > "ExpandedPathFile
END
ELSE DO
	SAY "IF NOT EXIST "ExpandedPathFile".org CP "ExpandedPathFile" "ExpandedPathFile".org"
	SAY "SED -f sed.tmp  < "ExpandedPathFile".org > "ExpandedPathFile
END
RETURN

/*---------------- check for double-changed files ------------------*/

checkAllSedChangedFiles:
PARSE ARG ExpandedPathFile

	sedFilesCnt = sedFilesCnt+1
	sedFiles.sedFilesCnt = ExpandedPathFile
	DO actSedFile = 1 TO sedFilesCnt-1
		IF sedFiles.sedFilesCnt = sedFiles.actSedFile THEN DO
			SAY ">>> double processed: "sedFiles.actSedFile
			exit 1
		END
	END
RETURN

/*---------------- used by the rexx "linkall" implementation ----------------*/

CopyHierachy:
PARSE ARG fromDir toDir
	"CP -r "fromDir"\* "toDir"\"
return

MkDirs:
PARSE ARG base machineDir
	"RM -r "base"\archi  2>nul"
	"MD "base"\archi  2>nul"
	"MD "base"\archi\"machineDir "2>nul"
	"MD "base"\archi\"machineDir"\bin 2>nul"
	"MD "base"\archi\"machineDir"\include 2>nul"
	"MD "base"\archi\"machineDir"\lib 2>nul"
return

exists:
'DIR "'arg(1)'" >nul 2>&1'
if rc = 0 THEN RETURN 1
RETURN 0
